//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Yellow
#property indicator_color2 Olive
#property indicator_color3 Olive
#property indicator_color4 Orange
#property indicator_color5 Orange
#property indicator_color6 Red
#property indicator_width6 2

//
//
//
//
//

extern string TimeFrame     = "Current time frame";
extern int    LR.length     = 55;
extern double std.channel.1 =  1;
extern double std.channel.2 =  2;
extern int    Price         = PRICE_CLOSE;
extern bool   Interpolate   = true;

//
//
//
//
//

double lrBuffer[];
double upBuffer1[];
double dnBuffer1[];
double upBuffer2[];
double dnBuffer2[];
double slBuffer[];
double prices[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,lrBuffer);  SetIndexLabel(0,"mean");
   SetIndexBuffer(1,upBuffer1); SetIndexLabel(1,"1st Std up");
   SetIndexBuffer(2,dnBuffer1); SetIndexLabel(2,"1st Std down");
   SetIndexBuffer(3,upBuffer2); SetIndexLabel(3,"2nd Std up");
   SetIndexBuffer(4,dnBuffer2); SetIndexLabel(4,"2nd Std down");
   SetIndexBuffer(5,slBuffer);  
   SetIndexBuffer(6,prices);
   
      //
      //
      //
      //
      //

      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" prd ("+LR.length+")");
   return(0);
}
int deinit() {}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,i,n,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { prices[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(i=limit; i>=0; i--)
      {
         prices[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         
         double slope;
         double value   = iLRValue(slope,LR.length,i);
         double std.dev = 0;

            for(int k=0; k<LR.length; k++)
            {
               double diff = prices[i+k]-(value-k*slope);
                  slBuffer[i+k] = value-k*slope;
                  std.dev += diff*diff;
            }
            slBuffer[i+k] = EMPTY_VALUE;
            std.dev = MathSqrt(std.dev/(LR.length-1.0));
      
         //
         //
         //
         //
         //
      
         lrBuffer[i]  = value;
         upBuffer1[i] = lrBuffer[i]+(std.channel.1*std.dev);
         dnBuffer1[i] = lrBuffer[i]-(std.channel.1*std.dev);
         upBuffer2[i] = lrBuffer[i]+(std.channel.2*std.dev);
         dnBuffer2[i] = lrBuffer[i]-(std.channel.2*std.dev);
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         lrBuffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,Price,0,y);
         upBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,Price,1,y);
         dnBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,Price,2,y);
         upBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,Price,3,y);
         dnBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,Price,4,y);
         slBuffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LR.length,std.channel.1,std.channel.2,Price,5,y);

         //
         //
         //
         //
         //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
            {
               lrBuffer[i+k]  = lrBuffer[i]  + (lrBuffer[i+n] -lrBuffer[i] )*k/n;
               upBuffer1[i+k] = upBuffer1[i] + (upBuffer1[i+n]-upBuffer1[i])*k/n;
               dnBuffer1[i+k] = dnBuffer1[i] + (dnBuffer1[i+n]-dnBuffer1[i])*k/n;
               upBuffer2[i+k] = upBuffer2[i] + (upBuffer2[i+n]-upBuffer2[i])*k/n;
               dnBuffer2[i+k] = dnBuffer2[i] + (dnBuffer2[i+n]-dnBuffer2[i])*k/n;
               if (slBuffer[i+n] != EMPTY_VALUE) slBuffer[i+k]  = slBuffer[i]  + (slBuffer[i+n] -slBuffer[i]) *k/n;
            }               
   }
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
//
//
//
//
//

int    lr.period=0;
double lr.sumX;
double lr.sumXSqr;
double lr.divisor;

//
//
//
//
//

double iLRValue(double& LinearRegSlope, int len, int shift)
{
   double LinearRegValue;
   double Intercept;
   double SumXY = 0;
   double SumY  = 0;

   //
   //
   //
   //
   //

   if (lr.period != len)
   {
      lr.period  = len;
      lr.sumX    = lr.period * (lr.period-1) / 2.0;
      lr.sumXSqr = lr.period * (lr.period-1) * (2.0 * lr.period - 1.0) / 6.0;
      lr.divisor = MathPow(lr.sumX,2.0) - lr.period * lr.sumXSqr;
   }

   //
   //
   //
   //
   //

   for (int i=0; i<lr.period; i++)
   {
      double price = prices[i+shift];
            SumXY += i*price;
            SumY  +=   price;
   }
   if( lr.divisor != 0 ) 
         	LinearRegSlope = (lr.period * SumXY - lr.sumX * SumY)/lr.divisor;
   else     LinearRegSlope = 0; 
   
   //
   //
   //
   //
   //
   
   Intercept      = (SumY - LinearRegSlope * lr.sumX) / lr.period ;
	LinearRegValue = Intercept  + LinearRegSlope * (lr.period-1);
   return(LinearRegValue);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}